stages :
    - build
    - test
    - deploy
    - deploy production
    - docker
    - test docker

variables:
    SURGE_DOMAIN_TEST: formation92-partage.surge.sh
    SURGE_DOMAIN_PROD: formation92-partage.surge.sh
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_PIPELINE_IID
    IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest

default:
    image: node:14
    cache:
        key: ${CI_COMMIT_REF_SLUG}
        paths:
            - .npm

build:
    stage: build
    script:
        - echo $CI_REGISTRY_USER
        - npm ci --cache .npm --prefer-offline
        - npm run build
    artifacts:
        paths:
            - ./public

test build:
    image: alpine:latest
    stage: test
    when: manual
    script :
        - grep "build something great" ./public/index.html

test server:
    stage: test
    when: manual
    script:
        - npm ci --cache .npm --prefer-offline
        - npm run serve &
        - sleep 5
        - curl http://localhost:9000 | tac | tac | grep "build something great"

deploy test:
    stage: deploy
    environment:
        name: test
        url: $SURGE_DOMAIN_TEST
        on_stop: stop test env
    only:
        - master
    when: manual
    script:
        - npx surge --project ./public --domain $SURGE_DOMAIN_TEST

deploy prod:
    stage: deploy production
    environment:
        name: production
        url: $SURGE_DOMAIN_PROD
    when: manual
    only:
        - master
    script:
        - npx surge --project ./public --domain $SURGE_DOMAIN_PROD

stop test env:
    stage: deploy
    environment:
        name: test
        action: stop
    when: manual
    script:
        - npx surge teardown $SURGE_DOMAIN_TEST

image docker:
    stage: docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    script:
        - echo $CI_REGISTRY_USER
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker build -t $IMAGE_TAG -t $IMAGE_TAG_LATEST .
        - docker push $IMAGE_TAG
        - docker push $IMAGE_TAG_LATEST

test docker:
    stage: test docker
    image: docker:20.10.7
    services:
        - docker:20.10.7-dind
    before_script:
        - apk add --update curl
    script:
        - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        - docker pull $IMAGE_TAG
        - docker run -d -p 8080:80 --name website $IMAGE_TAG
        - sleep 10
        - curl http://docker:8080 | tac | tac | grep -q "build something great"

